/*****************************************************
Project : AD7416 I2C
Version : v1.1
Date    : 2005.12.16
Author  : 
Company : 
Comments: AD7416 Temperature sensor reading and displaying to LCD

Chip type           : ATmega8
Program type        : Application
Clock frequency     : 8,000000 MHz
Memory model        : Small
External SRAM size  : 0
Data Stack size     : 256
*****************************************************/

#include <mega8.h>
#include <lcd.h>
#include <delay.h>
#include <math.h>
#include <stdio.h> // sprintf

int LSB,MSB, Data;
float temp, suma; 
int  kartai, i, termodaviklis;

// Alphanumeric LCD Module functions
#asm
   .equ __lcd_port=0x12 ;PORTD
#endasm

// LCD display buffer
char lcd_buffer[40];
                       

void initialization(){

PORTB=0x00;
DDRB=0x00;

PORTC=0x00;
DDRC=0xFF;

PORTD=0x00;
DDRD=0xFF;

TCCR0=0x00;
TCNT0=0x00;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: Timer 1 Stopped
// Mode: Normal top=FFFFh
// OC1A output: Discon.
// OC1B output: Discon.
// Noise Canceler: Off
// Input Capture on Falling Edge
// Timer 1 Overflow Interrupt: Off
// Input Capture Interrupt: Off
// Compare A Match Interrupt: Off
// Compare B Match Interrupt: Off
TCCR1A=0x00;
TCCR1B=0x00;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;

// Timer/Counter 2 initialization
// Clock source: System Clock
// Clock value: Timer 2 Stopped
// Mode: Normal top=FFh
// OC2 output: Disconnected
ASSR=0x00;
TCCR2=0x00;
TCNT2=0x00;
OCR2=0x00;

// External Interrupt(s) initialization
// INT0: Off
// INT1: Off
MCUCR=0x00;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x00;

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
ACSR=0x80;
SFIOR=0x00;

// 2 Wire Bus initialization
// Generate Acknowledge Pulse: On
// 2 Wire Bus Slave Address: 00h
// General Call Recognition: On
// Bit Rate: 400,000 kHz
TWSR=0x00;
TWCR=0x44;
TWBR=0x04;
TWAR=0x00;
}

// ----------------------Read data-------------------------------------------------
float temperatura (int termodaviklis) {
  int tt;
  suma=0; kartai=100;        
  for(i=1; i<=kartai; i++){         //average of temperature calculation

    do {
        TWCR=0b10100100; // I2C START
        while (!(TWCR&0b10000000)); // Waiting ACK
    } while ((TWSR&0b11111000)!=0x08); // Send start until success

        TWDR=termodaviklis; // address of sensor;
        TWCR=0b10000100; // TWINT flag cleared to continue transfer
        while (!(TWCR&0b10000000)); // Waiting ACK after transmit address and data

        TWCR=0b10000100; // TWINT flag cleared to continue transfer
        while (!(TWCR&0b10000000)); 
        MSB=TWDR; // Read MSB

        TWCR=0b10000100;
        while (!(TWCR&0b10000000));
        LSB=TWDR; // Read LSB

        TWCR=0b10010100; // I2C Stop
       
        LSB=0xC0 & LSB;
        LSB=LSB>>6; 
        tt=((MSB<<8)+LSB)>>6;
        if ((tt>>9)&1)              //calculation of temeprature and detecting sign
                {  
                        tt=tt&0b0111111111;
                        temp=-((tt-512)*0.25);
                }
        else{
                temp=tt*0.25;
        }
        suma=suma+temp;
  }            
  temp=suma/kartai;
  return temp;
}
               
void main(void) {
  char sign;        
  
        initialization();
        /* initialize the LCD for 2 lines & 16 columns */
        lcd_init(16);
        lcd_clear();

        lcd_gotoxy(2,0);
        sprintf(lcd_buffer, "Temperature");
        lcd_puts(lcd_buffer);
        lcd_gotoxy(6,1);
        sprintf(lcd_buffer, "Test");
        lcd_puts(lcd_buffer);
        delay_ms(2000);
        lcd_clear();

while (1){

        termodaviklis=0b10010001;
        temp = temperatura (termodaviklis);
        lcd_gotoxy(1,0);
        sprintf(lcd_buffer, "T = %.2f\xDFC", temp);
        lcd_puts(lcd_buffer);  
                      
}
}
